Functions

# string.cpp File Reference

Handling of C-type strings (char*). More...

`#include "stdafx.h"`
`#include "debug.h"`
`#include "core/alloc_func.hpp"`
`#include "core/math_func.hpp"`
`#include "string_func.h"`
`#include "table/control_codes.h"`
`#include <stdarg.h>`
`#include <ctype.h>`
`#include <unicode/ustring.h>`
`#include "language.h"`
`#include "gfx_func.h"`

Go to the source code of this file.

## Functions
static int CDECL | vseprintf (char *str, const char *last, const char *format, va_list ap)
| Safer implementation of vsnprintf; same as vsnprintf except: last instead of size, i.e.
void | ttd_strlcat (char *dst, const char *src, size_t size)
| Appends characters from one string to another.
void | ttd_strlcpy (char *dst, const char *src, size_t size)
| Copies characters from one buffer to another.
char * | strecat (char *dst, const char *src, const char *last)
| Appends characters from one string to another.
char * | strecpy (char *dst, const char *src, const char *last)
| Copies characters from one buffer to another.
char *CDECL | str_fmt (const char *str,...)
| Format, "printf", into a newly allocated string.
void | str_fix_scc_encoded (char *str, const char *last)
| Scan the string for old values of SCC_ENCODED and fix it to it's new, static value.
void | str_validate (char *str, const char *last, StringValidationSettings settings)
| Scans the string for valid characters and if it finds invalid ones, replaces them with a question mark '?' (if not ignored).
bool | StrValid (const char *str, const char *last)
| Checks whether the given string is valid, i.e.
void | str_strip_colours (char *str)
| Scans the string for colour codes and strips them.
size_t | Utf8StringLength (const char *s)
| Get the length of an UTF-8 encoded string in number of characters and thus not the number of bytes that the encoded string contains.
bool | strtolower (char *str)
| Convert a given ASCII string to lowercase.
bool | IsValidChar (WChar key, CharSetFilter afilter)
| Only allow certain keys.
int CDECL | seprintf (char *str, const char *last, const char *format,...)
| Safer implementation of snprintf; same as snprintf except: last instead of size, i.e.
char * | md5sumToString (char *buf, const char *last, const uint8 md5sum[16])
| Convert the md5sum to a hexadecimal string representation.
size_t | Utf8Decode (WChar *c, const char *s)
| Decode and consume the next UTF-8 encoded character.
size_t | Utf8Encode (char *buf, WChar c)
| Encode a unicode character and place it in the buffer.
size_t | Utf8TrimString (char *s, size_t maxlen)
| Properly terminate an UTF8 string to some maximum length.
static const char * | SkipGarbage (const char *str)
| Skip some of the 'garbage' in the string that we don't want to use to sort on.
int | strnatcmp (const char *s1, const char *s2, bool ignore_garbage_at_front)
| Compares two strings using case insensitive natural sort.

## Detailed Description

Handling of C-type strings (char*).

Definition in file string.cpp.

## Function Documentation

bool IsValidChar | ( | WChar | key,
|  | CharSetFilter | afilter |
| ) |  |  |

Only allow certain keys.

You can define the filter to be used. This makes sure no invalid keys can get into an editbox, like BELL.

Parameters:

  | key | character to be checked
  | afilter | the filter to use

Returns:
  true or false depending if the character is printable/valid or not

Definition at line 365 of file string.cpp.

References CS_ALPHA, CS_ALPHANUMERAL, CS_HEXADECIMAL, CS_NUMERAL, and CS_NUMERAL_SPACE.

Referenced by IConsoleCmdExec(), Textbuf::InsertClipboard(), OskWindow::OnClick(), IConsoleWindow::OnKeyPress(), TranslateTTDPatchCodes(), and OskWindow::UpdateOskState().

char* md5sumToString | ( | char * | buf,
|  | const char * | last,
|  | const uint8 | md5sum[16] |
| ) |  |  |

Convert the md5sum to a hexadecimal string representation.

Parameters:

  | buf | buffer to put the md5sum into
  | last | last character of buffer (usually lastof(buf))
  | md5sum | the md5sum itself

Returns:
  a pointer to the next character after the md5sum

Definition at line 457 of file string.cpp.

References seprintf().

Referenced by HandleSavegameLoadCrash(), IsGoodGRFConfigList(), MakePNGImage(), NetworkContentListWindow::OpenExternalSearch(), PrintGrfInfo(), and ClientNetworkGameSocketHandler::Receive_SERVER_CHECK_NEWGRFS().

int CDECL seprintf | ( | char * | str,
|  | const char * | last,
|  | const char * | format,
|  |  | ... |
| ) |  |  |

Safer implementation of snprintf; same as snprintf except:

- last instead of size, i.e.

replace sizeof with lastof.

- return gives the amount of characters added, not what it would add.
  Parameters:

    | str | buffer to write to up to last
    | last | last character we may write to
    | format | the formatting (see snprintf)

  Returns:
    the number of added characters

Definition at line 439 of file string.cpp.

References vseprintf().

Referenced by CheckExternalFiles(), CloneVehicleName(), CrashLogOSX::DisplayCrashDialog(), ClientNetworkContentSocketHandler::DownloadSelectedContentHTTP(), NetworkContentListWindow::DrawDetails(), AIInfo::DummyConstructor(), CrashLog::FillCrashLog(), FormatBytes(), FormatNumber(), FormatString(), CrashLog::GamelogFillCrashLog(), NetworkAddress::GetAddressAsString(), BlitterFactoryBase::GetBlittersInfo(), ScriptScanner::GetConsoleList(), DriverFactoryBase::GetDriversInfo(), GetFiosItem(), GetLanguageList(), BaseMedia< Tbase_set >::GetSetsList(), GetTextfile(), GRFBuildParamList(), HandleSavegameLoadCrash(), IniSaveSettings(), ScriptInstance::LoadCompatibilityScripts(), LoadTranslations(), CrashLog::LogCompiler(), CrashLog::LogConfiguration(), CrashLogWindows::LogError(), CrashLogUnix::LogError(), CrashLogOSX::LogError(), CrashLog::LogGamelog(), CrashLog::LogLibraries(), CrashLogWindows::LogModules(), CrashLog::LogOpenTTDVersion(), CrashLogWindows::LogOSVersion(), CrashLogUnix::LogOSVersion(), CrashLogOSX::LogOSVersion(), CrashLogWindows::LogRegisters(), CrashLogWindows::LogStacktrace(), CrashLogUnix::LogStacktrace(), CrashLogOSX::LogStacktrace(), MakeIntList(), MakeManyOfMany(), MakeOneOfMany(), MakePNGImage(), md5sumToString(), NetworkHTTPSocketHandler::NetworkHTTPSocketHandler(), NetworkContentListWindow::OpenExternalSearch(), NetworkAddress::Resolve(), Script_CreateDummy(), Script_CreateDummyInfo(), SetFallbackFont(), ShowErrorMessage(), ShowHelp(), CrashLog::WriteCrashLog(), and CrashLog::WriteSavegame().

static const char* SkipGarbage | ( | const char * | str | ) | `[static]`

Skip some of the 'garbage' in the string that we don't want to use to sort on.

This way the alphabetical sorting will work better as we would be actually using those characters instead of some other characters such as spaces and tildes at the begin of the name.

Parameters:

  | str | The string to skip the initial garbage of.

Returns:
  The string with the garbage skipped.

Definition at line 607 of file string.cpp.

References IsInsideMM().

Referenced by strnatcmp().

void str_fix_scc_encoded | ( | char * | str,
|  | const char * | last |
| ) |  |  |

Scan the string for old values of SCC_ENCODED and fix it to it's new, static value.

Parameters:

  | str | the string to scan
  | last | the last valid character of str

Definition at line 187 of file string.cpp.

References Utf8Decode(), Utf8Encode(), and Utf8EncodedCharLen().

Referenced by SlString().

char* CDECL str_fmt | ( | const char * | str,
|  |  | ... |
| ) |  |  |

Format, "printf", into a newly allocated string.

Parameters:

  | str | The formatting string.

Returns:
  The formatted string. You must free this!

Definition at line 168 of file string.cpp.

References lastof, and vseprintf().

Referenced by DEF_CONSOLE_CMD(), DeterminePaths(), and BaseSet< T, Tnum_files, Tsearch_in_tars >::FillSetDetails().

void str_validate | ( | char * | str,
|  | const char * | last,
|  | StringValidationSettings | settings |
| ) |  |  |

Scans the string for valid characters and if it finds invalid ones, replaces them with a question mark '?' (if not ignored).

Parameters:

  | str | the string to validate
  | last | the last valid character of str
  | settings | the settings for the string validation.

Definition at line 213 of file string.cpp.

References SVS_ALLOW_CONTROL_CODE, SVS_ALLOW_NEWLINE, SVS_REPLACE_WITH_QUESTION_MARK, Utf8Decode(), and Utf8EncodedCharLen().

Referenced by FiosFileScanner::AddFile(), FiosGetFileList(), GetFileTitle(), IConsolePrint(), TextfileWindow::LoadTextfile(), Packet::Recv_string(), and SlString().

char* strecat | ( | char * | dst,
|  | const char * | src,
|  | const char * | last |
| ) |  |  |

Appends characters from one string to another.

Appends the source string to the destination string with respect of the terminating null-character and and the last pointer to the last element in the destination buffer. If the last pointer is set to NULL no boundary check is performed.

Note:
  usage: strecat(dst, src, lastof(dst));
  lastof() applies only to fixed size arrays

Parameters:

  | dst | The buffer containing the target string
  | src | The buffer containing the string to append
  | last | The pointer to the last element of the destination buffer

Returns:
  The pointer to the terminating null-character in the destination buffer

Definition at line 117 of file string.cpp.

References strecpy().

Referenced by CloneVehicleName(), DoAutosave(), DrawRoadVehDetails(), FormatString(), GetDebugString(), GetFileTitle(), GetFullFilename(), KeycodeToString(), ClientNetworkUDPSocketHandler::Receive_SERVER_RESPONSE(), SaveKeycodes(), IniFile::SaveToDisk(), and ServerNetworkGameSocketHandler::SendCompanyInfo().

char* strecpy | ( | char * | dst,
|  | const char * | src,
|  | const char * | last |
| ) |  |  |

Copies characters from one buffer to another.

Copies the source string to the destination buffer with respect of the terminating null-character and the last pointer to the last element in the destination buffer. If the last pointer is set to NULL no boundary check is performed.

Note:
  usage: strecpy(dst, src, lastof(dst));
  lastof() applies only to fixed size arrays

Parameters:

  | dst | The destination buffer
  | src | The buffer containing the string to copy
  | last | The pointer to the last element of the destination buffer

Returns:
  The pointer to the terminating null-character in the destination buffer

Definition at line 145 of file string.cpp.

References DEBUG, and error().

Referenced by ScriptScanner::AddFile(), ScenarioScanner::AddFile(), FiosFileScanner::AddFile(), TarScanner::AddFile(), CloneVehicleName(), DrawString(), DrawStringMultiLine(), DumpDebugFacilityNames(), ExtractTar(), FioFOpenFile(), FiosGetFileList(), FiosMakeHeightmapName(), FormatNumber(), FormatString(), GamelogRevision(), GenerateTownNameString(), NetworkAddress::GetAddressAsString(), GetFileTitle(), GetKeyboardLayout(), GetStringHeight(), GetTextfile(), GRFBuildParamList(), FileStringReader::HandlePragma(), IConsoleCopyInParams(), IniSaveSettings(), IsSameScript(), LoadTranslations(), MakeAustrianTownName(), MakeCatalanTownName(), MakeCzechTownName(), MakeDanishTownName(), MakeDutchTownName(), MakeEnglishAdditionalTownName(), MakeEnglishOriginalTownName(), MakeFinnishTownName(), MakeFrenchTownName(), MakeGermanTownName(), MakeHungarianTownName(), MakeItalianTownName(), MakeNorwegianTownName(), MakePNGImage(), MakePolishTownName(), MakeRomanianTownName(), MakeScreenshot(), MakeScreenshotName(), MakeSillyTownName(), MakeSlovakTownName(), MakeSpanishTownName(), MakeSwedishTownName(), MakeSwissTownName(), MakeTurkishTownName(), NetworkAddChatMessage(), NetworkAddress::NetworkAddress(), NetworkFindBroadcastIPsInternal(), NetworkGameListHandleDelayedInsert(), NetworkSendCommand(), NetworkServerChangeClientName(), NetworkServerSetCompanyPassword(), NetworkUDPQueryServer(), NetworkUpdateClientName(), SaveLoadWindow::OnClick(), BaseNetworkContentDownloadStatusWindow::OnDownloadProgress(), NetworkStartServerWindow::OnEditboxChanged(), NetworkGameWindow::OnEditboxChanged(), AIDebugWindow::OnEditboxChanged(), CustomCurrencyWindow::OnQueryTextFinished(), NetworkStartServerWindow::OnQueryTextFinished(), ClientNetworkContentSocketHandler::OnReceiveData(), NetworkContentListWindow::OpenExternalSearch(), StringReader::ParseFile(), MusicDriver_Win32::PlaySong(), MusicDriver_ExtMidi::PlaySong(), ReadLanguagePack(), ServerNetworkUDPSocketHandler::Receive_CLIENT_FIND_SERVER(), ServerNetworkUDPSocketHandler::Receive_CLIENT_GET_NEWGRFS(), ClientNetworkGameSocketHandler::Receive_SERVER_CLIENT_INFO(), ReconsiderGameScriptLanguage(), DriverFactoryBase::RegisterDriver(), NetworkAddress::Resolve(), IniFile::SaveToDisk(), FileScanner::Scan(), Script_CreateDummy(), DriverFactoryBase::SelectDriver(), ServerNetworkGameSocketHandler::SendCompanyInfo(), TextfileWindow::SetFontNames(), LanguagePackGlyphSearcher::SetFontNames(), SetScreenshotFormat(), ShowHelp(), strecat(), CrashLog::WriteScreenshot(), and DriverFactoryBase::~DriverFactoryBase().

int strnatcmp | ( | const char * | s1,
|  | const char * | s2,
|  | bool | ignore_garbage_at_front |
| ) |  |  |

Compares two strings using case insensitive natural sort.

Parameters:

  | s1 | First string to compare.
  | s2 | Second string to compare.
  | ignore_garbage_at_front | Skip punctuation characters in the front

Returns:
  Less than zero if s1 < s2, zero if s1 == s2, greater than zero if s1 > s2.

Definition at line 621 of file string.cpp.

References _current_collator, DRAW_STRING_BUFFER, lengthof, and SkipGarbage().

Referenced by CargoSpecNameSorter(), EngineNameSorter(), VehicleGroupWindow::GroupNameSorter(), IndustryDirectoryWindow::IndustryNameSorter(), IndustryTypeNameSorter(), NewGRFWindow::NameSorter(), NetworkContentListWindow::NameSorter(), DropDownListStringItem::NatSortFunc(), NetworkGameWindow::NGameNameSorter(), SignList::SignNameSorter(), TownDirectoryWindow::TownNameSorter(), NetworkContentListWindow::TypeSorter(), and VehicleNameSorter().

bool strtolower | ( | char * | str | ) |

Convert a given ASCII string to lowercase.

NOTE: only support ASCII characters, no UTF8 fancy. As currently the function is only used to lowercase data-filenames if they are not found, this is sufficient. If more, or general functionality is needed, look to r7271 where it was removed because it was broken when using certain locales: eg in Turkish the uppercase 'I' was converted to '?', so just revert to the old functionality

Parameters:

  | str | string to convert

Returns:
  String has changed.

Definition at line 347 of file string.cpp.

Referenced by GameScannerInfo::FindInfo(), AIScannerInfo::FindInfo(), GameScannerLibrary::FindLibrary(), AIScannerLibrary::FindLibrary(), FioFindFullPath(), FioFOpenFile(), FioOpenFile(), ScriptScanner::RegisterScript(), and SimplifyFileName().

bool StrValid | ( | const char * | str,
|  | const char * | last |
| ) |  |  |

Checks whether the given string is valid, i.e.

contains only valid (printable) characters and is properly terminated.

Parameters:

  | str | The string to validate.
  | last | The last character of the string, i.e. the string must be terminated here or earlier.

Definition at line 274 of file string.cpp.

References Utf8Decode(), and Utf8EncodedCharLen().

Referenced by LanguagePackHeader::IsValid().

void ttd_strlcat | ( | char * | dst,
|  | const char * | src,
|  | size_t | size |
| ) |  |  |

Appends characters from one string to another.

Appends the source string to the destination string with respect of the terminating null-character and the maximum size of the destination buffer.

Note:
  usage ttd_strlcat(dst, src, lengthof(dst));
  lengthof() applies only to fixed size arrays

Parameters:

  | dst | The buffer containing the target string
  | src | The buffer containing the string to append
  | size | The maximum size of the destination buffer

Definition at line 65 of file string.cpp.

References ttd_strlcpy().

Referenced by BuildWithFullPath(), and ScriptInstance::LoadCompatibilityScripts().

void ttd_strlcpy | ( | char * | dst,
|  | const char * | src,
|  | size_t | size |
| ) |  |  |

Copies characters from one buffer to another.

Copies the source string to the destination buffer with respect of the terminating null-character and the maximum size of the destination buffer.

Note:
  usage ttd_strlcpy(dst, src, lengthof(dst));
  lengthof() applies only to fixed size arrays

Parameters:

  | dst | The destination buffer
  | src | The buffer containing the string to copy
  | size | The maximum size of the destination buffer

Definition at line 91 of file string.cpp.

Referenced by Textbuf::Assign(), BuildWithFullPath(), GameScannerInfo::FindInfo(), AIScannerInfo::FindInfo(), FioCreateDirectory(), ServerNetworkGameSocketHandler::GetClientName(), GetClipboardContents(), IniLoadSettings(), mkpath(), NetworkFindName(), SetSettingValue(), ShowMissingContentWindow(), and ttd_strlcat().

size_t Utf8Decode | ( | WChar * | c,
|  | const char * | s |
| ) |  |  |

Decode and consume the next UTF-8 encoded character.

Parameters:

  | c | Buffer to place decoded character.
  | s | Character stream to retrieve character from.

Returns:
  Number of characters in the sequence.

Definition at line 478 of file string.cpp.

References GB(), and HasBit().

Referenced by Textbuf::DelChar(), DrawString(), FormatString(), Textbuf::GetNextDelChar(), GlobalVarChangeInfo(), Textbuf::MoveCaretLeft(), Textbuf::MoveCaretRight(), StringFilter::SetFilterTerm(), str_fix_scc_encoded(), str_strip_colours(), str_validate(), StrValid(), and TranslateTTDPatchCodes().

size_t Utf8Encode | ( | char * | buf,
|  | WChar | c |
| ) |  |  |

Encode a unicode character and place it in the buffer.

Parameters:

  | buf | Buffer to place character.
  | c | Unicode character to encode.

Returns:
  Number of characters in the encoded sequence.

Definition at line 518 of file string.cpp.

References GB().

Referenced by CheckForMissingGlyphs(), CopyFromOldName(), DrawNewsString(), UnmappedChoiceList::Flush(), FormatString(), FS2OTTD(), str_fix_scc_encoded(), and TranslateTTDPatchCodes().

size_t Utf8StringLength | ( | const char * | s | ) |

Get the length of an UTF-8 encoded string in number of characters and thus not the number of bytes that the encoded string contains.

Parameters:

  | s | The string to get the length for.

Returns:
  The length of the string in characters.

Definition at line 327 of file string.cpp.

Referenced by CmdFoundTown(), CmdPlaceSign(), CmdRenameCompany(), CmdRenameDepot(), CmdRenameEngine(), CmdRenameGroup(), CmdRenamePresident(), CmdRenameSign(), CmdRenameStation(), CmdRenameTown(), CmdRenameVehicle(), CmdRenameWaypoint(), GenerateCompanyName(), GeneratePresidentName(), and VerifyTownName().

size_t Utf8TrimString | ( | char * | s,
|  | size_t | maxlen |
| ) |  |  |

Properly terminate an UTF8 string to some maximum length.

Parameters:

  | s | string to check if it needs additional trimming
  | maxlen | the maximum length the buffer can have.

Returns:
  the new length in bytes of the string (eg. strlen(new_string))

Note:
  maxlen is the string length _INCLUDING_ the terminating ''

Definition at line 552 of file string.cpp.

References Utf8EncodedCharLen().

Referenced by NetworkAddChatMessage().

static int CDECL vseprintf | ( | char * | str,
|  | const char * | last,
|  | const char * | format,
|  | va_list | ap |
| ) |  |  | `[static]`

Safer implementation of vsnprintf; same as vsnprintf except:

- last instead of size, i.e.

replace sizeof with lastof.

- return gives the amount of characters added, not what it would add.
  Parameters:

    | str | buffer to write to up to last
    | last | last character we may write to
    | format | the formatting (see snprintf)
    | ap | the list of arguments for the format

  Returns:
    the number of added characters

Definition at line 44 of file string.cpp.

References min().

Referenced by MidiSendCommand(), seprintf(), and str_fmt().